OGRE: Ogre::ParticleSystem Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Classes | Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Static Public Attributes | List of all members
Ogre::ParticleSystem Class Reference
Core » Effects

Class defining particle system based special effects. More...

`#include <OgreParticleSystem.h>`

Inheritance diagram for Ogre::ParticleSystem:
[legend]

## Classes
class | CmdCull
| Command object for cull_each (see ParamCommand). More...
class | CmdEmittedEmitterQuota
| Command object for emittedEmitterQuota (see ParamCommand). More...
class | CmdHeight
| Command object for particle_height (see ParamCommand). More...
class | CmdIterationInterval
| Command object for iteration interval(see ParamCommand). More...
class | CmdLocalSpace
| Command object for local space (see ParamCommand). More...
class | CmdMaterial
| Command object for material (see ParamCommand). More...
class | CmdNonvisibleTimeout
| Command object for nonvisible timeout (see ParamCommand). More...
class | CmdQuota
| Command object for quota (see ParamCommand). More...
class | CmdRenderer
| Command object for renderer (see ParamCommand). More...
class | CmdSorted
| Command object for sorting (see ParamCommand). More...
class | CmdWidth
| Command object for particle_width (see ParamCommand). More...

## Public Types
typedef FastArray< MovableObject * > | MovableObjectArray
| @See SceneManager::cullFrustum More...

## Public Member Functions
| ParticleSystem (IdType id, ObjectMemoryManager *objectMemoryManager, SceneManager *manager, const String &resourceGroupName)
| Creates a particle system with no emitters or affectors. More...
virtual | ~ParticleSystem ()
ParticleIterator | _getIterator (void)
| Returns an iterator for stepping through all particles in this system. More...
LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object. More...
SceneManager * | _getManager (void) const
| Get the manager of this object, if any (internal use only) More...
ObjectData & | _getObjectData ()
| Returns a direct access to the ObjectData state. More...
const Matrix4 & | _getParentNodeFullTransform (void) const
| Returns the full transformation of the parent sceneNode or the attachingPoint node. More...
void | _notifyAttached (Node *parent)
| Overridden from MovableObject. More...
void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only) More...
void | _notifyOrigin (const String &origin)
| Notify this particle system of it's origin. More...
virtual void | _notifyParentNodeMemoryChanged (void)
| @See Node::_callMemoryChangeListeners More...
virtual void | _notifyParticleResized (void)
| Internal callback used by Particles to notify their parent that they have been resized. More...
virtual void | _notifyParticleRotated (void)
| Internal callback used by Particles to notify their parent that they have been rotated. More...
virtual void | _notifyStaticDirty (void) const
| Called by SceneManager when it is telling we're a static MovableObject being dirty Don't call this directly. More...
virtual void | _releaseManualHardwareResources ()
| Notifies the movable object that hardware resources were lost. More...
virtual void | _restoreManualHardwareResources ()
| Notifies the movable object that hardware resources should be restored. More...
void | _update (Real timeElapsed)
| Updates the particles in the system based on time elapsed. More...
void | _updateBounds (void)
| Internal method for updating the bounds of the particle system. More...
virtual void | _updateRenderQueue (RenderQueue *queue, Camera *camera, const Camera *lodCamera)
| Overridden from MovableObject. More...
ParticleAffector * | addAffector (const String &affectorType)
| Adds an affector to this particle system. More...
ParticleEmitter * | addEmitter (const String &emitterType)
| Adds an emitter to this particle system. More...
void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object. More...
void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object. More...
void | clear ()
| Empties this set of all particles. More...
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object. More...
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value. More...
Particle * | createEmitterParticle (const String &emitterName)
| Manually add an emitter particle to the system. More...
Particle * | createParticle (void)
| Manually add a particle to the system. More...
void | detachFromParent (void)
| Detaches an object from a parent SceneNode if attached. More...
void | fastForward (Real time, Real interval=0.1)
| Fast-forwards this system by the required number of seconds. More...
ParticleAffector * | getAffector (unsigned short index) const
| Retrieves an affector by it's index (zero-based). More...
const StringVector & | getAnimableValueNames (void) const
| Gets a list of animable value names for this object. More...
RealAsUint | getCachedDistanceToCamera (void) const
| Returns the distance to camera as calculated in @cullFrustum. More...
Real | getCachedDistanceToCameraAsReal (void) const
| Returns the distance to camera as calculated in @cullFrustum. More...
bool | getCastShadows (void) const
| Returns whether shadow casting is enabled for this object. More...
virtual bool | getCullIndividually (void) const
| Returns whether or not particles in this are tested individually for culling. More...
unsigned char | getCurrentMeshLod (void) const
virtual Real | getDefaultHeight (void) const
| See setDefaultDimensions - this gets 1 component individually. More...
virtual Real | getDefaultWidth (void) const
| See setDefaultDimensions - this gets 1 component individually. More...
size_t | getEmittedEmitterQuota (void) const
| Returns the maximum number of emitted emitters this system is allowed to have active at once. More...
ParticleEmitter * | getEmitter (unsigned short index) const
| Retrieves an emitter by it's index (zero-based). More...
bool | getEmitting () const
| Returns true if the particle system emitting flag is turned on. More...
IdType | getId () const
| Get the unique id of this object. More...
Real | getIterationInterval (void) const
| Gets a 'iteration interval' on this particle system. More...
bool | getKeepParticlesInLocalSpace (void) const
| Gets whether particles (and any affector effects) remain relative to the node the particle system is attached to. More...
uint32 | getLightMask () const
| Get a bitwise mask which will filter the lights affecting this object. More...
Listener * | getListener (void) const
| Gets the current listener for this object. More...
Aabb | getLocalAabb (void) const
| Retrieves the local axis-aligned bounding box for this object. More...
float | getLocalRadius (void) const
| See getLocalAabb and getWorldRadius. More...
virtual const String & | getMaterialName (void) const
| Sets the name of the material to be used for this billboard set. More...
const String & | getMovableType (void) const
| Overridden from MovableObject. More...
const String & | getName (void) const
| Returns the name of this object. More...
Real | getNonVisibleUpdateTimeout (void) const
| Gets when the particle system should stop updating after it hasn't been visible for a while. More...
unsigned short | getNumAffectors (void) const
| Returns the number of affectors for this particle system. More...
unsigned short | getNumEmitters (void) const
| Returns the number of emitters for this particle system. More...
size_t | getNumParticles (void) const
| Gets the number of individual particles in the system right now. More...
const String & | getOrigin (void) const
| Get the origin of this particle system, e.g. More...
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class. More...
const ParamDictionary * | getParamDictionary (void) const
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method. More...
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object. More...
Node * | getParentNode (void) const
| Returns the node to which this object is attached. More...
SceneNode * | getParentSceneNode (void) const
Particle * | getParticle (size_t index)
| Retrieve a particle from the system for manual tweaking. More...
size_t | getParticleQuota (void) const
| Returns the maximum number of particles this system is allowed to have active at once. More...
uint32 | getQueryFlags (void) const
| Returns the query flags relevant for this object. More...
ParticleSystemRenderer * | getRenderer (void) const
| Gets the ParticleRenderer to be used to render this particle system. More...
const String & | getRendererName (void) const
| Gets the name of the ParticleRenderer to be used to render this particle system. More...
Real | getRenderingDistance (void) const
| Gets the distance at which batches are no longer rendered. More...
Real | getRenderingMinPixelSize () const
| Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered. More...
uint8 | getRenderQueueGroup (void) const
| Gets the queue group for this entity, see setRenderQueueGroup for full details. More...
virtual const String & | getResourceGroupName (void) const
| Return the resource group to be used to load dependent resources. More...
Real | getShadowRenderingDistance (void) const
| Gets the distance at which batches are no longer casting shadows. More...
SkeletonInstance * | getSkeletonInstance (void) const
bool | getSortingEnabled (void) const
| Gets whether particles are sorted relative to the camera. More...
Real | getSpeedFactor (void) const
| Gets the 'speed factor' on this particle system. More...
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class. More...
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class. More...
uint32 | getVisibilityFlags (void) const
| Returns the visibility flags relevant for this object. More...
bool | getVisible (void) const
| Gets this object whether to be visible or not, if it has a renderable component. More...
Aabb | getWorldAabb () const
| Gets the axis aligned box in world space. More...
Aabb | getWorldAabbUpdated ()
| Gets the axis aligned box in world space. More...
float | getWorldRadius () const
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ). More...
float | getWorldRadiusUpdated ()
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ). More...
virtual void | instanceBatchCullFrustumThreaded (const Frustum *frustum, const Camera *lodCamera, uint32 combinedVisibilityFlags)
| @See InstancingTheadedCullingMethod, More...
bool | isAttached (void) const
| Returns true if this object is attached to a Node. More...
bool | isStatic () const
| Checks whether this MovableObject is static. @See setStatic. More...
bool | isVisible (void) const
| Returns whether or not this object is supposed to be visible or not. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
bool | operator() (const IdObject &left, const IdObject &right)
bool | operator() (const IdObject *left, const IdObject *right)
ParticleSystem & | operator= (const ParticleSystem &rhs)
| Assignment operator for copying. More...
const LightList & | queryLights (void) const
| Gets a list of lights, ordered relative to how close they are to this movable object. More...
void | removeAffector (unsigned short index)
| Removes an affector from the system. More...
void | removeAllAffectors (void)
| Removes all the affectors from this system. More...
void | removeAllEmitters (void)
| Removes all the emitters from this system. More...
void | removeEmitter (ParticleEmitter *emitter)
| Removes an emitter from the system. More...
void | removeEmitter (unsigned short index)
| Removes an emitter from the system. More...
void | removeQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object. More...
void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object. More...
void | setBoundsAutoUpdated (bool autoUpdate, Real stopIn=0.0f)
| Sets whether the bounds will be automatically updated for the life of the particle system. More...
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows. More...
virtual void | setCullIndividually (bool cullIndividual)
| Sets whether culling tests particles in this individually as well as in a group. More...
virtual void | setDefaultDimensions (Real width, Real height)
| Sets the default dimensions of the particles in this set. More...
virtual void | setDefaultHeight (Real height)
| See setDefaultDimensions - this sets 1 component individually. More...
virtual void | setDefaultWidth (Real width)
| See setDefaultDimensions - this sets 1 component individually. More...
void | setEmittedEmitterQuota (size_t quota)
| Sets the maximum number of emitted emitters this system is allowed to have active at once. More...
void | setEmitting (bool v)
| This is used to turn on or off particle emission for this system. More...
void | setIterationInterval (Real iterationInterval)
| Sets a 'iteration interval' on this particle system. More...
void | setKeepParticlesInLocalSpace (bool keepLocal)
| Sets whether particles (and any affector effects) remain relative to the node the particle system is attached to. More...
void | setLightMask (uint32 lightMask)
| Set a bitwise mask which will filter the lights affecting this object. More...
void | setListener (Listener *listener)
| Sets a listener for this object. More...
void | setLocalAabb (const Aabb box)
| Sets the local axis-aligned bounding box for this object. More...
virtual void | setMaterialName (const String &name, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| Sets the name of the material to be used for this billboard set. More...
void | setName (const String &name)
| Sets a custom name for this node. More...
void | setNonVisibleUpdateTimeout (Real timeout)
| Sets when the particle system should stop updating after it hasn't been visible for a while. More...
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method. More...
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method. More...
void | setParticleQuota (size_t quota)
| Sets the maximum number of particles this system is allowed to have active at once. More...
void | setQueryFlags (uint32 flags)
| Sets the query flags for this object. More...
void | setRenderer (const String &typeName)
| Sets the ParticleRenderer to be used to render this particle system. More...
void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered. More...
void | setRenderingMinPixelSize (Real pixelSize)
| Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered. More...
void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through. More...
void | setRenderQueueSubGroup (uint8 subGroup)
void | setShadowRenderingDistance (Real dist)
| Sets the distance at which the object is no longer casting shadows. More...
void | setSortingEnabled (bool enabled)
| Set whether or not particles are sorted according to the camera. More...
void | setSpeedFactor (Real speedFactor)
| Sets a 'speed factor' on this particle system, which means it scales the elapsed real time which has passed by this factor before passing it to the emitters, affectors, and the particle life calculation. More...
bool | setStatic (bool bStatic)
| Turns this Node into static or dynamic. More...
void | setVisibilityFlags (uint32 flags)
| Sets the visibility flags for this object. More...
void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component. More...

## Static Public Member Functions
static void | buildLightList (const size_t numNodes, ObjectData t, const LightListInfo &globalLightList)
| @See SceneManager::buildLightList More...
static void | calculateCastersBox (const size_t numNodes, ObjectData t, uint32 sceneVisibilityFlags, AxisAlignedBox *outBox)
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g. More...
static void | cullFrustum (const size_t numNodes, ObjectData t, const Camera *frustum, uint32 sceneVisibilityFlags, MovableObjectArray &outCulledObjects, const Camera *lodCamera)
static void | cullLights (const size_t numNodes, ObjectData t, uint32 sceneLightMask, LightListInfo &outGlobalLightList, const FrustumVec &frustums, const FrustumVec &cubemapFrustums)
| @See SceneManager::cullLights & More...
static Real | getDefaultIterationInterval (void)
| Get the default iteration interval for all ParticleSystem instances. More...
static uint32 | getDefaultLightMask ()
| Get the default light mask for all future MovableObject instances. More...
static Real | getDefaultNonVisibleUpdateTimeout (void)
| Get the default nonvisible timeout for all ParticleSystem instances. More...
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances. More...
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances. More...
static void | setDefaultIterationInterval (Real iterationInterval)
| Set the default iteration interval for all ParticleSystem instances. More...
static void | setDefaultLightMask (uint32 mask)
| Set the default light mask for all future MovableObject instances. More...
static void | setDefaultNonVisibleUpdateTimeout (Real timeout)
| Set the default nonvisible timeout for all ParticleSystem instances. More...
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances. More...
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances. More...
static void | updateAllBounds (const size_t numNodes, ObjectData t)
| @See SceneManager::updateAllBounds More...

## Public Attributes
size_t | mGlobalIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks). More...
size_t | mParentIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks). More...
RenderableArray | mRenderables

## Static Public Attributes
static const FastArray< Real > | c_DefaultLodMesh

## Detailed Description

Class defining particle system based special effects.

Remarks
  Particle systems are special effects generators which are based on a number of moving points to create the impression of things like like sparkles, smoke, blood spurts, dust etc.

  This class simply manages a single collection of particles in world space with a shared local origin for emission. The visual aspect of the particles is handled by a ParticleSystemRenderer instance.

  Particle systems are created using the SceneManager, never directly. In addition, like all subclasses of MovableObject, the ParticleSystem will only be considered for rendering once it has been attached to a SceneNode.

## Member Typedef Documentation

## ◆ MovableObjectArray

typedef FastArray<MovableObject*> Ogre::MovableObject::MovableObjectArray
| inherited

@See SceneManager::cullFrustum

Remarks
  We don't pass by reference on purpose (avoid implicit aliasing) We perform frustum culling AND test visibility mask at the same time

Parameters

  frustum | Frustum to clip against
  sceneVisibilityFlags | Combined scene's visibility flags (i.e. viewport | scene). Set LAYER_SHADOW_CASTER bit if you want to exclude non-shadow casters.
  outCulledObjects | Out. List of objects that are (fully or partially) inside the frustum and should be rendered
  lodCamera | Camera in which lod levels calculations are based (i.e. during shadow pass renders) Note however, we only use this camera to calulate if should be visible according to mUpperDistance

## Constructor & Destructor Documentation

## ◆ ParticleSystem()

Ogre::ParticleSystem::ParticleSystem | ( | IdType | id,
|  | ObjectMemoryManager * | objectMemoryManager,
|  | SceneManager * | manager,
|  | const String & | resourceGroupName
| ) |  |

Creates a particle system with no emitters or affectors.

Remarks
  You should use the ParticleSystemManager to create particle systems rather than creating them directly.

## ◆ ~ParticleSystem()

virtual Ogre::ParticleSystem::~ParticleSystem | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ _getIterator()

ParticleIterator Ogre::ParticleSystem::_getIterator | ( | void |  | ) |

Returns an iterator for stepping through all particles in this system.

Remarks
  This method is designed to be used by people providing new ParticleAffector subclasses, this is the easiest way to step through all the particles in a system and apply the changes the affector wants to make.

## ◆ _getLightList()

LightList* Ogre::MovableObject::_getLightList | ( |  | ) |
| inlineinherited

Returns a pointer to the current list of lights for this object.

Remarks
  You should not modify this list outside of MovableObject::Listener::objectQueryLights (say if you want to use it to implement this method, and use the pointer as a return value) and for reading it's only accurate as at the last frame.

## ◆ _getManager()

SceneManager* Ogre::MovableObject::_getManager | ( | void |  | ) | const
| inlineinherited

Get the manager of this object, if any (internal use only)

## ◆ _getObjectData()

ObjectData& Ogre::MovableObject::_getObjectData | ( |  | ) |
| inlineinherited

Returns a direct access to the ObjectData state.

## ◆ _getParentNodeFullTransform()

const Matrix4& Ogre::MovableObject::_getParentNodeFullTransform | ( | void |  | ) | const
| inherited

Returns the full transformation of the parent sceneNode or the attachingPoint node.

## ◆ _notifyAttached()

void Ogre::ParticleSystem::_notifyAttached | ( | Node * | parent | ) |
| virtual

Overridden from MovableObject.

See also
  MovableObject

Reimplemented from Ogre::MovableObject.

## ◆ _notifyManager()

void Ogre::MovableObject::_notifyManager | ( | SceneManager * | man | ) |
| inlineinherited

Notify the object of it's manager (internal use only)

## ◆ _notifyOrigin()

void Ogre::ParticleSystem::_notifyOrigin | ( | const String & | origin | ) |
| inline

Notify this particle system of it's origin.

## ◆ _notifyParentNodeMemoryChanged()

virtual void Ogre::MovableObject::_notifyParentNodeMemoryChanged | ( | void |  | ) |
| inlinevirtualinherited

@See Node::_callMemoryChangeListeners

Reimplemented in Ogre::Item.

## ◆ _notifyParticleResized()

virtual void Ogre::ParticleSystem::_notifyParticleResized | ( | void |  | ) |
| virtual

Internal callback used by Particles to notify their parent that they have been resized.

## ◆ _notifyParticleRotated()

virtual void Ogre::ParticleSystem::_notifyParticleRotated | ( | void |  | ) |
| virtual

Internal callback used by Particles to notify their parent that they have been rotated.

## ◆ _notifyStaticDirty()

virtual void Ogre::MovableObject::_notifyStaticDirty | ( | void |  | ) | const
| inlinevirtualinherited

Called by SceneManager when it is telling we're a static MovableObject being dirty Don't call this directly.

See also
  SceneManager::notifyStaticDirty

## ◆ _releaseManualHardwareResources()

virtual void Ogre::MovableObject::_releaseManualHardwareResources | ( |  | ) |
| inlinevirtualinherited

Notifies the movable object that hardware resources were lost.

Remarks
  Called automatically by RenderSystem if hardware resources were lost and can not be restored using some internal mechanism. Among affected resources are nested shadow renderables, ManualObjects, etc.

Reimplemented in Ogre::v1::ManualObject, and Ogre::v1::BillboardSet.

## ◆ _restoreManualHardwareResources()

virtual void Ogre::MovableObject::_restoreManualHardwareResources | ( |  | ) |
| inlinevirtualinherited

Notifies the movable object that hardware resources should be restored.

Remarks
  Called automatically by RenderSystem if hardware resources were lost and can not be restored using some internal mechanism. Among affected resources are nested shadow renderables, ManualObjects, etc.

## ◆ _update()

void Ogre::ParticleSystem::_update | ( | Real | timeElapsed | ) |

Updates the particles in the system based on time elapsed.

Remarks
  This is called automatically every frame by OGRE.

Parameters

  timeElapsed | The amount of time, in seconds, since the last frame.

## ◆ _updateBounds()

void Ogre::ParticleSystem::_updateBounds | ( | void |  | ) |

Internal method for updating the bounds of the particle system.

Remarks
  This is called automatically for a period of time after the system's creation (10 seconds by default, settable by setBoundsAutoUpdated) to increase (and only increase) the bounds of the system according to the emitted and affected particles. After this period, the system is assumed to achieved its maximum size, and the bounds are no longer computed for efficiency. You can tweak the behaviour by either setting the bounds manually (setBounds, preferred), or changing the time over which the bounds are updated (performance cost). You can also call this method manually if you need to update the bounds on an ad-hoc basis.

## ◆ _updateRenderQueue()

virtual void Ogre::ParticleSystem::_updateRenderQueue | ( | RenderQueue * | queue,
|  | Camera * | camera,
|  | const Camera * | lodCamera
| ) |  |
| virtual

Overridden from MovableObject.

See also
  MovableObject

Reimplemented from Ogre::MovableObject.

## ◆ addAffector()

ParticleAffector* Ogre::ParticleSystem::addAffector | ( | const String & | affectorType | ) |

Adds an affector to this particle system.

Remarks
  Particles are modified over time in a particle system by affectors - see the ParticleAffector class for more details.

Parameters

  affectorType | String identifying the affector type to create. Affector types are defined by registering new factories with the manager - see ParticleAffectorFactory for more details. Affector types can be extended by OGRE, plugin authors or application developers.

## ◆ addEmitter()

ParticleEmitter* Ogre::ParticleSystem::addEmitter | ( | const String & | emitterType | ) |

Adds an emitter to this particle system.

Remarks
  Particles are created in a particle system by emitters - see the ParticleEmitter class for more details.

Parameters

  emitterType | String identifying the emitter type to create. Emitter types are defined by registering new factories with the manager - see ParticleEmitterFactory for more details. Emitter types can be extended by OGRE, plugin authors or application developers.

## ◆ addQueryFlags()

void Ogre::MovableObject::addQueryFlags | ( | uint32 | flags | ) |
| inlineinherited

As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.

## ◆ addVisibilityFlags()

void Ogre::MovableObject::addVisibilityFlags | ( | uint32 | flags | ) |
| inlineinherited

As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.

## ◆ buildLightList()

static void Ogre::MovableObject::buildLightList | ( | const size_t | numNodes,
|  | ObjectData | t,
|  | const LightListInfo & | globalLightList
| ) |  |
| staticinherited

@See SceneManager::buildLightList

Remarks
  We don't pass by reference on purpose (avoid implicit aliasing)

Parameters

  globalLightList | List of lights already culled against all possible frustums and reorganized contiguously for SoA

## ◆ calculateCastersBox()

static void Ogre::MovableObject::calculateCastersBox | ( | const size_t | numNodes,
|  | ObjectData | t,
|  | uint32 | sceneVisibilityFlags,
|  | AxisAlignedBox * | outBox
| ) |  |
| staticinherited

## ◆ cleanupDictionary()

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) |
| staticinherited

Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

MaterialManager) initializes.

## ◆ clear()

void Ogre::ParticleSystem::clear | ( |  | ) |

Empties this set of all particles.

## ◆ copyParametersTo()

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const
| inlinevirtualinherited

Method for copying this object's parameters to another object.

Remarks
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters

  dest | Pointer to object to have it's parameters set the same as this object.

References Ogre::StringInterface::setParameter().

## ◆ createAnimableValue()

virtual AnimableValuePtr Ogre::AnimableObject::createAnimableValue | ( | const String & | valueName | ) |
| inlinevirtualinherited

Create a reference-counted AnimableValuePtr for the named value.

Remarks
  You can use the returned object to animate a value on this object, using AnimationTrack. Subclasses must override this if they wish to support animation of their values.

Reimplemented in Ogre::Light.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

## ◆ createEmitterParticle()

Particle* Ogre::ParticleSystem::createEmitterParticle | ( | const String & | emitterName | ) |

Manually add an emitter particle to the system.

Remarks
  The purpose of a particle emitter is to emit particles. Besides visual particles, also other other particle types can be emitted, other emitters for example. The emitted emitters have a double role; they behave as particles and can be influenced by affectors, but they are still emitters and capable to emit other particles (or emitters). It is possible to create a chain of emitters - emitters emitting other emitters, which also emit emitters.

Parameters

  emitterName | The name of a particle emitter that must be emitted.

## ◆ createParticle()

Particle* Ogre::ParticleSystem::createParticle | ( | void |  | ) |

Manually add a particle to the system.

Remarks
  Instead of using an emitter, you can manually add a particle to the system. You must initialise the returned particle instance immediately with the 'emission' state.

Note
  There is no corresponding 'destroyParticle' method - if you want to dispose of a particle manually (say, if you've used setSpeedFactor(0) to make particles live forever) you should use getParticle() and modify it's timeToLive to zero, meaning that it will get cleaned up in the next update.

## ◆ cullFrustum()

static void Ogre::MovableObject::cullFrustum | ( | const size_t | numNodes,
|  | ObjectData | t,
|  | const Camera * | frustum,
|  | uint32 | sceneVisibilityFlags,
|  | MovableObjectArray & | outCulledObjects,
|  | const Camera * | lodCamera
| ) |  |
| staticinherited

## ◆ cullLights()

static void Ogre::MovableObject::cullLights | ( | const size_t | numNodes,
|  | ObjectData | t,
|  | uint32 | sceneLightMask,
|  | LightListInfo & | outGlobalLightList,
|  | const FrustumVec & | frustums,
|  | const FrustumVec & | cubemapFrustums
| ) |  |
| staticinherited

@See SceneManager::cullLights &

See also
  MovableObject::cullFrustum Produces the global list of visible lights that is needed in buildLightList

Remarks
  We don't pass ObjectData by reference on purpose (avoid implicit aliasing) It's declared here because all affected elements are from MovableObject IMPORTANT: It is assumed that all objects in ObjectData are Lights.

Parameters

  outGlobalLightList | Output, a list of lights, contiguously placed
  frustums | An array of all frustums we need to check against
  cubemapFrustums | An array of all frustums that are used at least once as cubemaps (@See SceneManager::createCamera)

## ◆ detachFromParent()

void Ogre::MovableObject::detachFromParent | ( | void |  | ) |
| inherited

Detaches an object from a parent SceneNode if attached.

## ◆ fastForward()

void Ogre::ParticleSystem::fastForward | ( | Real | time,
|  | Real | interval = `0.1`
| ) |  |

Fast-forwards this system by the required number of seconds.

Remarks
  This method allows you to fast-forward a system so that it effectively looks like it has already been running for the time you specify. This is useful to avoid the 'startup sequence' of a system, when you want the system to be fully populated right from the start.

Parameters

  time | The number of seconds to fast-forward by.
  interval | The sampling interval used to generate particles, apply affectors etc. The lower this is the more realistic the fast-forward, but it takes more iterations to do it.

## ◆ getAffector()

ParticleAffector* Ogre::ParticleSystem::getAffector | ( | unsigned short | index | ) | const

Retrieves an affector by it's index (zero-based).

Remarks
  Used to retrieve a pointer to an affector for a particle system to procedurally change affector parameters etc. You should check how many affectors are registered against this system before calling this method with an arbitrary index using getNumAffectors.

Parameters

  index | Zero-based index of the affector to retrieve.

## ◆ getAnimableValueNames()

const StringVector& Ogre::AnimableObject::getAnimableValueNames | ( | void |  | ) | const
| inlineinherited

Gets a list of animable value names for this object.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

## ◆ getCachedDistanceToCamera()

RealAsUint Ogre::MovableObject::getCachedDistanceToCamera | ( | void |  | ) | const
| inlineinherited

Returns the distance to camera as calculated in @cullFrustum.

## ◆ getCachedDistanceToCameraAsReal()

Real Ogre::MovableObject::getCachedDistanceToCameraAsReal | ( | void |  | ) | const
| inlineinherited

Returns the distance to camera as calculated in @cullFrustum.

## ◆ getCastShadows()

bool Ogre::MovableObject::getCastShadows | ( | void |  | ) | const
| inlineinherited

Returns whether shadow casting is enabled for this object.

## ◆ getCullIndividually()

virtual bool Ogre::ParticleSystem::getCullIndividually | ( | void |  | ) | const
| virtual

Returns whether or not particles in this are tested individually for culling.

## ◆ getCurrentMeshLod()

unsigned char Ogre::MovableObject::getCurrentMeshLod | ( | void |  | ) | const
| inlineinherited

## ◆ getDefaultHeight()

virtual Real Ogre::ParticleSystem::getDefaultHeight | ( | void |  | ) | const
| virtual

See setDefaultDimensions - this gets 1 component individually.

## ◆ getDefaultIterationInterval()

static Real Ogre::ParticleSystem::getDefaultIterationInterval | ( | void |  | ) |
| inlinestatic

Get the default iteration interval for all ParticleSystem instances.

## ◆ getDefaultLightMask()

static uint32 Ogre::MovableObject::getDefaultLightMask | ( |  | ) |
| inlinestaticinherited

Get the default light mask for all future MovableObject instances.

## ◆ getDefaultNonVisibleUpdateTimeout()

static Real Ogre::ParticleSystem::getDefaultNonVisibleUpdateTimeout | ( | void |  | ) |
| inlinestatic

Get the default nonvisible timeout for all ParticleSystem instances.

## ◆ getDefaultQueryFlags()

static uint32 Ogre::MovableObject::getDefaultQueryFlags | ( |  | ) |
| inlinestaticinherited

Get the default query flags for all future MovableObject instances.

## ◆ getDefaultVisibilityFlags()

static uint32 Ogre::MovableObject::getDefaultVisibilityFlags | ( |  | ) |
| inlinestaticinherited

Get the default visibility flags for all future MovableObject instances.

## ◆ getDefaultWidth()

virtual Real Ogre::ParticleSystem::getDefaultWidth | ( | void |  | ) | const
| virtual

See setDefaultDimensions - this gets 1 component individually.

## ◆ getEmittedEmitterQuota()

size_t Ogre::ParticleSystem::getEmittedEmitterQuota | ( | void |  | ) | const

Returns the maximum number of emitted emitters this system is allowed to have active at once.

Remarks
  See ParticleSystem::setEmittedEmitterQuota for more info.

## ◆ getEmitter()

ParticleEmitter* Ogre::ParticleSystem::getEmitter | ( | unsigned short | index | ) | const

Retrieves an emitter by it's index (zero-based).

Remarks
  Used to retrieve a pointer to an emitter for a particle system to procedurally change emission parameters etc. You should check how many emitters are registered against this system before calling this method with an arbitrary index using getNumEmitters.

Parameters

  index | Zero-based index of the emitter to retrieve.

## ◆ getEmitting()

bool Ogre::ParticleSystem::getEmitting | ( |  | ) | const

Returns true if the particle system emitting flag is turned on.

Remarks
  This function will not actually return whether the particles are being emitted. It only returns the value of emitting flag.

## ◆ getId()

IdType Ogre::IdObject::getId | ( |  | ) | const
| inlineinherited

Get the unique id of this object.

## ◆ getIterationInterval()

Real Ogre::ParticleSystem::getIterationInterval | ( | void |  | ) | const
| inline

Gets a 'iteration interval' on this particle system.

## ◆ getKeepParticlesInLocalSpace()

bool Ogre::ParticleSystem::getKeepParticlesInLocalSpace | ( | void |  | ) | const
| inline

Gets whether particles (and any affector effects) remain relative to the node the particle system is attached to.

## ◆ getLightMask()

uint32 Ogre::MovableObject::getLightMask | ( |  | ) | const
| inlineinherited

Get a bitwise mask which will filter the lights affecting this object.

Remarks
  By default, this mask is fully set meaning all lights will affect this object

## ◆ getListener()

Listener* Ogre::MovableObject::getListener | ( | void |  | ) | const
| inlineinherited

Gets the current listener for this object.

## ◆ getLocalAabb()

Aabb Ogre::MovableObject::getLocalAabb | ( | void |  | ) | const
| inherited

Retrieves the local axis-aligned bounding box for this object.

Remarks
  This bounding box is in local coordinates.

## ◆ getLocalRadius()

float Ogre::MovableObject::getLocalRadius | ( | void |  | ) | const
| inherited

See getLocalAabb and getWorldRadius.

## ◆ getMaterialName()

virtual const String& Ogre::ParticleSystem::getMaterialName | ( | void |  | ) | const
| virtual

Sets the name of the material to be used for this billboard set.

Returns
  The name of the material that is used for this set.

## ◆ getMovableType()

const String& Ogre::ParticleSystem::getMovableType | ( | void |  | ) | const
| virtual

Overridden from MovableObject.

Implements Ogre::MovableObject.

## ◆ getName()

const String& Ogre::MovableObject::getName | ( | void |  | ) | const
| inlineinherited

Returns the name of this object.

## ◆ getNonVisibleUpdateTimeout()

Real Ogre::ParticleSystem::getNonVisibleUpdateTimeout | ( | void |  | ) | const
| inline

Gets when the particle system should stop updating after it hasn't been visible for a while.

## ◆ getNumAffectors()

unsigned short Ogre::ParticleSystem::getNumAffectors | ( | void |  | ) | const

Returns the number of affectors for this particle system.

## ◆ getNumEmitters()

unsigned short Ogre::ParticleSystem::getNumEmitters | ( | void |  | ) | const

Returns the number of emitters for this particle system.

## ◆ getNumParticles()

size_t Ogre::ParticleSystem::getNumParticles | ( | void |  | ) | const

Gets the number of individual particles in the system right now.

Remarks
  The number of particles active in a system at a point in time depends on the number of emitters, their emission rates, the time-to-live (TTL) each particle is given on emission (and whether any affectors modify that TTL) and the maximum number of particles allowed in this system at once (particle quota).

## ◆ getOrigin()

const String& Ogre::ParticleSystem::getOrigin | ( | void |  | ) | const
| inline

Get the origin of this particle system, e.g.

a script file name.

Remarks
  This property will only contain something if the creator of this particle system chose to populate it. Script loaders are advised to populate it.

## ◆ getParamDictionary() [1/2]

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) |
| inlineinherited

Retrieves the parameter dictionary for this class.

Remarks
  Only valid to call this after createParamDictionary.

Returns
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

## ◆ getParamDictionary() [2/2]

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const
| inlineinherited

## ◆ getParameter()

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const
| inlinevirtualinherited

Generic parameter retrieval method.

Remarks
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters

  name | The name of the parameter to get

Returns
  String value of parameter, blank if not found

References Ogre::ParamCommand::doGet().

## ◆ getParameters()

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const
| inherited

Retrieves a list of parameters valid for this object.

Returns
  A reference to a static list of ParameterDef objects.

## ◆ getParentNode()

Node* Ogre::MovableObject::getParentNode | ( | void |  | ) | const
| inlineinherited

Returns the node to which this object is attached.

## ◆ getParentSceneNode()

SceneNode* Ogre::MovableObject::getParentSceneNode | ( | void |  | ) | const
| inlineinherited

## ◆ getParticle()

Particle* Ogre::ParticleSystem::getParticle | ( | size_t | index | ) |

Retrieve a particle from the system for manual tweaking.

Remarks
  Normally you use an affector to alter particles in flight, but for small manually controlled particle systems you might want to use this method.

## ◆ getParticleQuota()

size_t Ogre::ParticleSystem::getParticleQuota | ( | void |  | ) | const

Returns the maximum number of particles this system is allowed to have active at once.

Remarks
  See ParticleSystem::setParticleQuota for more info.

## ◆ getQueryFlags()

uint32 Ogre::MovableObject::getQueryFlags | ( | void |  | ) | const
| inlineinherited

Returns the query flags relevant for this object.

## ◆ getRenderer()

ParticleSystemRenderer* Ogre::ParticleSystem::getRenderer | ( | void |  | ) | const

Gets the ParticleRenderer to be used to render this particle system.

## ◆ getRendererName()

const String& Ogre::ParticleSystem::getRendererName | ( | void |  | ) | const

Gets the name of the ParticleRenderer to be used to render this particle system.

## ◆ getRenderingDistance()

Real Ogre::MovableObject::getRenderingDistance | ( | void |  | ) | const
| inlineinherited

Gets the distance at which batches are no longer rendered.

## ◆ getRenderingMinPixelSize()

Real Ogre::MovableObject::getRenderingMinPixelSize | ( |  | ) | const
| inlineinherited

Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered.

## ◆ getRenderQueueGroup()

uint8 Ogre::MovableObject::getRenderQueueGroup | ( | void |  | ) | const
| inlineinherited

Gets the queue group for this entity, see setRenderQueueGroup for full details.

## ◆ getResourceGroupName()

virtual const String& Ogre::ParticleSystem::getResourceGroupName | ( | void |  | ) | const
| inlinevirtual

Return the resource group to be used to load dependent resources.

## ◆ getShadowRenderingDistance()

Real Ogre::MovableObject::getShadowRenderingDistance | ( | void |  | ) | const
| inlineinherited

Gets the distance at which batches are no longer casting shadows.

## ◆ getSkeletonInstance()

SkeletonInstance* Ogre::MovableObject::getSkeletonInstance | ( | void |  | ) | const
| inlineinherited

## ◆ getSortingEnabled()

bool Ogre::ParticleSystem::getSortingEnabled | ( | void |  | ) | const
| inline

Gets whether particles are sorted relative to the camera.

## ◆ getSpeedFactor()

Real Ogre::ParticleSystem::getSpeedFactor | ( | void |  | ) | const
| inline

Gets the 'speed factor' on this particle system.

## ◆ getUserObjectBindings() [1/2]

UserObjectBindings& Ogre::MovableObject::getUserObjectBindings | ( |  | ) |
| inlineinherited

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also
  UserObjectBindings::setUserAny.

## ◆ getUserObjectBindings() [2/2]

const UserObjectBindings& Ogre::MovableObject::getUserObjectBindings | ( |  | ) | const
| inlineinherited

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also
  UserObjectBindings::setUserAny.

## ◆ getVisibilityFlags()

uint32 Ogre::MovableObject::getVisibilityFlags | ( | void |  | ) | const
| inlineinherited

Returns the visibility flags relevant for this object.

Reserved visibility flags are not returned.

## ◆ getVisible()

bool Ogre::MovableObject::getVisible | ( | void |  | ) | const
| inlineinherited

Gets this object whether to be visible or not, if it has a renderable component.

Remarks
  Returns the value set by MovableObject::setVisible only.

## ◆ getWorldAabb()

Aabb Ogre::MovableObject::getWorldAabb | ( |  | ) | const
| inherited

Gets the axis aligned box in world space.

Remarks
  Assumes the caches are already updated. Will trigger an assert otherwise. @See getWorldAabbUpdated if you need the update process to be guaranteed

## ◆ getWorldAabbUpdated()

Aabb Ogre::MovableObject::getWorldAabbUpdated | ( |  | ) |
| inherited

Gets the axis aligned box in world space.

Remarks
  Unlike getWorldAabb, this function guarantees the cache stays up to date. It is STRONGLY advised against calling this function for a large number of MovableObject. Refactor your queries so that they happen after SceneManager::updateAllBounds() has been called

## ◆ getWorldRadius()

float Ogre::MovableObject::getWorldRadius | ( |  | ) | const
| inherited

Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).

Remarks
  Assumes the caches are already updated. Will trigger an assert otherwise. @See getWorldRadiusUpdated if you need the update process to be guaranteed

## ◆ getWorldRadiusUpdated()

float Ogre::MovableObject::getWorldRadiusUpdated | ( |  | ) |
| inherited

Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).

Remarks
  Unlike getWorldRadius, this function guarantees the cache stays up to date. It is STRONGLY advised against calling this function for a large number of MovableObject. Refactor your queries so that they happen after SceneManager::updateAllBounds() has been called

## ◆ instanceBatchCullFrustumThreaded()

virtual void Ogre::MovableObject::instanceBatchCullFrustumThreaded | ( | const Frustum * | frustum,
|  | const Camera * | lodCamera,
|  | uint32 | combinedVisibilityFlags
| ) |  |
| inlinevirtualinherited

@See InstancingTheadedCullingMethod,

See also
  InstanceBatch::instanceBatchCullFrustumThreaded

## ◆ isAttached()

bool Ogre::MovableObject::isAttached | ( | void |  | ) | const
| inlineinherited

Returns true if this object is attached to a Node.

## ◆ isStatic()

bool Ogre::MovableObject::isStatic | ( |  | ) | const
| inherited

Checks whether this MovableObject is static. @See setStatic.

## ◆ isVisible()

bool Ogre::MovableObject::isVisible | ( | void |  | ) | const
| inherited

Returns whether or not this object is supposed to be visible or not.

Remarks
  Takes into account visibility flags and the setVisible, but not rendering distance.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ operator()() [1/2]

bool Ogre::IdObject::operator() | ( | const IdObject & | left,
|  | const IdObject & | right
| ) |  |
| inlineinherited

## ◆ operator()() [2/2]

bool Ogre::IdObject::operator() | ( | const IdObject * | left,
|  | const IdObject * | right
| ) |  |
| inlineinherited

## ◆ operator=()

ParticleSystem& Ogre::ParticleSystem::operator= | ( | const ParticleSystem & | rhs | ) |

Assignment operator for copying.

Remarks
  This operator deep copies all particle emitters and effectors, but not particles. The system's name is also not copied.

## ◆ queryLights()

const LightList& Ogre::MovableObject::queryLights | ( | void |  | ) | const
| inlineinherited

Gets a list of lights, ordered relative to how close they are to this movable object.

Remarks
  The lights are filled in

See also
  buildLightList

Returns
  The list of lights use to lighting this object.

## ◆ removeAffector()

void Ogre::ParticleSystem::removeAffector | ( | unsigned short | index | ) |

Removes an affector from the system.

Remarks
  Drops the affector with the index specified from this system. You should check how many affectors are registered against this system before calling this method with an arbitrary index using getNumAffectors.

Parameters

  index | Zero-based index of the affector to retrieve.

## ◆ removeAllAffectors()

void Ogre::ParticleSystem::removeAllAffectors | ( | void |  | ) |

Removes all the affectors from this system.

## ◆ removeAllEmitters()

void Ogre::ParticleSystem::removeAllEmitters | ( | void |  | ) |

Removes all the emitters from this system.

## ◆ removeEmitter() [1/2]

void Ogre::ParticleSystem::removeEmitter | ( | ParticleEmitter * | emitter | ) |

Removes an emitter from the system.

Remarks
  Drops the emitter from this system.

Parameters

  emitter | Pointer to a particle emitter.

## ◆ removeEmitter() [2/2]

void Ogre::ParticleSystem::removeEmitter | ( | unsigned short | index | ) |

Removes an emitter from the system.

Remarks
  Drops the emitter with the index specified from this system. You should check how many emitters are registered against this system before calling this method with an arbitrary index using getNumEmitters.

Parameters

  index | Zero-based index of the emitter to retrieve.

## ◆ removeQueryFlags()

void Ogre::MovableObject::removeQueryFlags | ( | uint32 | flags | ) |
| inlineinherited

As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.

## ◆ removeVisibilityFlags()

void Ogre::MovableObject::removeVisibilityFlags | ( | uint32 | flags | ) |
| inlineinherited

As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.

## ◆ setBoundsAutoUpdated()

void Ogre::ParticleSystem::setBoundsAutoUpdated | ( | bool | autoUpdate,
|  | Real | stopIn = `0.0f`
| ) |  |

Sets whether the bounds will be automatically updated for the life of the particle system.

Remarks
  If you have a stationary particle system, it would be a good idea to call this method and set the value to 'false', since the maximum bounds of the particle system will eventually be static. If you do this, you can either set the bounds manually using the setBounds() method, or set the second parameter of this method to a positive number of seconds, so that the bounds are calculated for a few seconds and then frozen.

Parameters

  autoUpdate | If true (the default), the particle system will update it's bounds every frame. If false, the bounds update will cease after the 'stopIn' number of seconds have passed.
  stopIn | Only applicable if the first parameter is true, this is the number of seconds after which the automatic update will cease.

## ◆ setCastShadows()

void Ogre::MovableObject::setCastShadows | ( | bool | enabled | ) |
| inlineinherited

Sets whether or not this object will cast shadows.

Remarks
  This setting simply allows you to turn on/off shadows for a given object. An object will not cast shadows unless the scene supports it in any case (see SceneManager::setShadowTechnique), and also the material which is in use must also have shadow casting enabled. By default all entities cast shadows. If, however, for some reason you wish to disable this for a single object then you can do so using this method.

Note
  This method normally refers to objects which block the light, but since Light is also a subclass of MovableObject, in that context it means whether the light causes shadows itself.

## ◆ setCullIndividually()

virtual void Ogre::ParticleSystem::setCullIndividually | ( | bool | cullIndividual | ) |
| virtual

Sets whether culling tests particles in this individually as well as in a group.

Remarks
  Particle sets are always culled as a whole group, based on a bounding box which encloses all particles in the set. For fairly localised sets, this is enough. However, you can optionally tell the set to also cull individual particles in the set, i.e. to test each individual particle before rendering. The default is not to do this.

  This is useful when you have a large, fairly distributed set of particles, like maybe trees on a landscape. You probably still want to group them into more than one set (maybe one set per section of landscape), which will be culled coarsely, but you also want to cull the particles individually because they are spread out. Whilst you could have lots of single-tree sets which are culled separately, this would be inefficient to render because each tree would be issued as it's own rendering operation.

  By calling this method with a parameter of true, you can have large particle sets which are spaced out and so get the benefit of batch rendering and coarse culling, but also have fine-grained culling so unnecessary rendering is avoided.

Parameters

  cullIndividual | If true, each particle is tested before being sent to the pipeline as well as the whole set having to pass the coarse group bounding test.

## ◆ setDefaultDimensions()

virtual void Ogre::ParticleSystem::setDefaultDimensions | ( | Real | width,
|  | Real | height
| ) |  |
| virtual

Sets the default dimensions of the particles in this set.

Remarks
  All particles in a set are created with these default dimensions. The set will render most efficiently if all the particles in the set are the default size. It is possible to alter the size of individual particles at the expense of extra calculation. See the Particle class for more info.

Parameters

  width | The new default width for the particles in this set. Must be non-negative!
  height | The new default height for the particles in this set. Must be non-negative!

## ◆ setDefaultHeight()

virtual void Ogre::ParticleSystem::setDefaultHeight | ( | Real | height | ) |
| virtual

See setDefaultDimensions - this sets 1 component individually.

## ◆ setDefaultIterationInterval()

static void Ogre::ParticleSystem::setDefaultIterationInterval | ( | Real | iterationInterval | ) |
| inlinestatic

Set the default iteration interval for all ParticleSystem instances.

## ◆ setDefaultLightMask()

static void Ogre::MovableObject::setDefaultLightMask | ( | uint32 | mask | ) |
| inlinestaticinherited

Set the default light mask for all future MovableObject instances.

## ◆ setDefaultNonVisibleUpdateTimeout()

static void Ogre::ParticleSystem::setDefaultNonVisibleUpdateTimeout | ( | Real | timeout | ) |
| inlinestatic

Set the default nonvisible timeout for all ParticleSystem instances.

## ◆ setDefaultQueryFlags()

static void Ogre::MovableObject::setDefaultQueryFlags | ( | uint32 | flags | ) |
| inlinestaticinherited

Set the default query flags for all future MovableObject instances.

## ◆ setDefaultVisibilityFlags()

static void Ogre::MovableObject::setDefaultVisibilityFlags | ( | uint32 | flags | ) |
| inlinestaticinherited

Set the default visibility flags for all future MovableObject instances.

## ◆ setDefaultWidth()

virtual void Ogre::ParticleSystem::setDefaultWidth | ( | Real | width | ) |
| virtual

See setDefaultDimensions - this sets 1 component individually.

## ◆ setEmittedEmitterQuota()

void Ogre::ParticleSystem::setEmittedEmitterQuota | ( | size_t | quota | ) |

Sets the maximum number of emitted emitters this system is allowed to have active at once.

Remarks
  Particle systems can have - besides a particle quota - also an emitted emitter quota.

Parameters

  quota | The maximum number of emitted emitters this system is allowed to have.

## ◆ setEmitting()

void Ogre::ParticleSystem::setEmitting | ( | bool | v | ) |

This is used to turn on or off particle emission for this system.

Remarks
  By default particle system is always emitting particles (if a emitters exists) and this can be used to stop the emission for all emitters. To turn it on again, call it passing true.

Note that this does not detach the particle system from the scene node, it will still use some CPU.

## ◆ setIterationInterval()

void Ogre::ParticleSystem::setIterationInterval | ( | Real | iterationInterval | ) |

Sets a 'iteration interval' on this particle system.

Remarks
  The default Particle system update interval, based on elapsed frame time, will cause different behavior between low frame-rate and high frame-rate. By using this option, you can make the particle system update at a fixed interval, keeping the behavior the same no matter what frame-rate is.

  When iteration interval is set to zero, it means the update occurs based on an elapsed frame time, otherwise each iteration will take place at the given interval, repeating until it has used up all the elapsed frame time.

Parameters

  iterationInterval | The iteration interval, default to zero.

## ◆ setKeepParticlesInLocalSpace()

void Ogre::ParticleSystem::setKeepParticlesInLocalSpace | ( | bool | keepLocal | ) |

Sets whether particles (and any affector effects) remain relative to the node the particle system is attached to.

Remarks
  By default particles are in world space once emitted, so they are not affected by movement in the parent node of the particle system. This makes the most sense when dealing with completely independent particles, but if you want to constrain them to follow local motion too, you can set this to true.

## ◆ setLightMask()

void Ogre::MovableObject::setLightMask | ( | uint32 | lightMask | ) |
| inlineinherited

Set a bitwise mask which will filter the lights affecting this object.

Remarks
  This mask will be compared against the mask held against Light to determine if a light should affect a given object. By default, this mask is fully set meaning all lights will affect this object

## ◆ setListener()

void Ogre::MovableObject::setListener | ( | Listener * | listener | ) |
| inlineinherited

Sets a listener for this object.

Remarks
  Note for size and performance reasons only one listener per object is allowed.

## ◆ setLocalAabb()

void Ogre::MovableObject::setLocalAabb | ( | const Aabb | box | ) |
| inherited

Sets the local axis-aligned bounding box for this object.

Remarks
  This bounding box is in local coordinates.

## ◆ setMaterialName()

virtual void Ogre::ParticleSystem::setMaterialName | ( | const String & | name,
|  | const String & | groupName = `ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME`
| ) |  |
| virtual

Sets the name of the material to be used for this billboard set.

Parameters

  name | The new name of the material to use for this set.

## ◆ setName()

void Ogre::MovableObject::setName | ( | const String & | name | ) |
| inlineinherited

Sets a custom name for this node.

Doesn't have to be unique

## ◆ setNonVisibleUpdateTimeout()

void Ogre::ParticleSystem::setNonVisibleUpdateTimeout | ( | Real | timeout | ) |

Sets when the particle system should stop updating after it hasn't been visible for a while.

Remarks
  By default, visible particle systems update all the time, even when not in view. This means that they are guaranteed to be consistent when they do enter view. However, this comes at a cost, updating particle systems can be expensive, especially if they are perpetual.

  This option lets you set a 'timeout' on the particle system, so that if it isn't visible for this amount of time, it will stop updating until it is next visible.

Parameters

  timeout | The time after which the particle system will be disabled if it is no longer visible. 0 to disable the timeout and always update.

## ◆ setParameter()

virtual bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value
| ) |  |
| virtualinherited

Generic parameter setting method.

Remarks
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters

  name | The name of the parameter to set
  value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

Referenced by Ogre::StringInterface::copyParametersTo().

## ◆ setParameterList()

virtual void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) |
| virtualinherited

Generic multiple parameter setting method.

Remarks
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters

  paramList | Name/value pair list

## ◆ setParticleQuota()

void Ogre::ParticleSystem::setParticleQuota | ( | size_t | quota | ) |

Sets the maximum number of particles this system is allowed to have active at once.

Remarks
  Particle systems all have a particle quota, i.e. a maximum number of particles they are allowed to have active at a time. This allows the application to set a keep particle systems under control should they be affected by complex parameters which alter their emission rates etc. If a particle system reaches it's particle quota, none of the emitters will be able to emit any more particles. As existing particles die, the spare capacity will be allocated equally across all emitters to be as consistent to the original particle system style as possible. The quota can be increased but not decreased after the system has been created.

Parameters

  quota | The maximum number of particles this system is allowed to have.

## ◆ setQueryFlags()

void Ogre::MovableObject::setQueryFlags | ( | uint32 | flags | ) |
| inlineinherited

Sets the query flags for this object.

Remarks
  When performing a scene query, this object will be included or excluded according to flags on the object and flags on the query. This is a bitwise value, so only when a bit on these flags is set, will it be included in a query asking for that flag. The meaning of the bits is application-specific.

## ◆ setRenderer()

void Ogre::ParticleSystem::setRenderer | ( | const String & | typeName | ) |

Sets the ParticleRenderer to be used to render this particle system.

Remarks
  The main ParticleSystem just manages the creation and movement of particles; they are rendered using functions in ParticleRenderer and the ParticleVisual instances they create.

Parameters

  typeName | String identifying the type of renderer to use; a new instance of this type will be created; a factory must have been registered with ParticleSystemManager.

## ◆ setRenderingDistance()

void Ogre::MovableObject::setRenderingDistance | ( | Real | dist | ) |
| inlineinherited

Sets the distance at which the object is no longer rendered.

Parameters

  dist | Distance beyond which the object will not be rendered (the default is FLT_MAX, which means objects are always rendered). Values equal or below zero will be ignored, and cause an assertion in debug mode.

## ◆ setRenderingMinPixelSize()

void Ogre::MovableObject::setRenderingMinPixelSize | ( | Real | pixelSize | ) |
| inlineinherited

Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered.

Note
  Camera::setUseMinPixelSize() needs to be called for this parameter to be used.

Parameters

  pixelSize | Number of minimum pixels (the default is 0, which means objects are always rendered).

## ◆ setRenderQueueGroup()

void Ogre::ParticleSystem::setRenderQueueGroup | ( | uint8 | queueID | ) |
| virtual

Sets the render queue group this entity will be rendered through.

Remarks
  Render queues are grouped to allow you to more tightly control the ordering of rendered objects. If you do not call this method, all Entity objects default to the default queue (RenderQueue::getDefaultQueueGroup), which is fine for most objects. You may want to alter this if you want this entity to always appear in front of other objects, e.g. for a 3D menu system or such.

  See RenderQueue for more details.

Parameters

  queueID | Enumerated value of the queue group to use. See the enum RenderQueueGroupID for what kind of values can be used here.

  Valid render queue ids are between 0 & 254 inclusive

Reimplemented from Ogre::MovableObject.

## ◆ setRenderQueueSubGroup()

void Ogre::ParticleSystem::setRenderQueueSubGroup | ( | uint8 | subGroup | ) |

## ◆ setShadowRenderingDistance()

void Ogre::MovableObject::setShadowRenderingDistance | ( | Real | dist | ) |
| inlineinherited

Sets the distance at which the object is no longer casting shadows.

Parameters

  dist | Distance beyond which the object will not cast shadows (the default is FLT_MAX, which means objects are always casting shadows). Values equal or below zero will be ignored, and cause an assertion in debug mode.

Note
  ShadowRenderingDistance will be clamped to RenderingDistance value

See also
  setRenderingDistance

## ◆ setSortingEnabled()

void Ogre::ParticleSystem::setSortingEnabled | ( | bool | enabled | ) |
| inline

Set whether or not particles are sorted according to the camera.

Remarks
  Enabling sorting alters the order particles are sent to the renderer. When enabled, particles are sent to the renderer in order of furthest distance from the camera.

## ◆ setSpeedFactor()

void Ogre::ParticleSystem::setSpeedFactor | ( | Real | speedFactor | ) |
| inline

Sets a 'speed factor' on this particle system, which means it scales the elapsed real time which has passed by this factor before passing it to the emitters, affectors, and the particle life calculation.

Remarks
  An interesting side effect - if you want to create a completely manual particle system where you control the emission and life of particles yourself, you can set the speed factor to 0.0f, thus disabling normal particle emission, alteration, and death.

## ◆ setStatic()

bool Ogre::MovableObject::setStatic | ( | bool | bStatic | ) |
| inherited

Turns this Node into static or dynamic.

Remarks
  Switching between dynamic and static has some overhead and forces to update all static scene when converted to static. So don't do it frequently. Static objects are not updated every frame, only when requested explicitly. Use this feature if you plan to have this object unaltered for a very long times

  Note all MovableObjects support switching between static & dynamic after they have been created (eg. InstancedEntity)

  Changing this attribute will cause to switch the attribute to our parent node, and as a result, all of its other attached entities. @See Node::setStatic

Returns
  True if setStatic made an actual change. False otherwise. Can fail because the object was already static/dynamic, or because switching is not supported

## ◆ setVisibilityFlags()

void Ogre::MovableObject::setVisibilityFlags | ( | uint32 | flags | ) |
| inlineinherited

Sets the visibility flags for this object.

Remarks
  As well as a simple true/false value for visibility (as seen in setVisible), you can also set visibility flags that is applied a binary 'and' with the SceneManager's mask and a compositor node pass. To exclude particular objects from rendering. Changes to reserved visibility flags are ignored (won't take effect).

## ◆ setVisible()

void Ogre::MovableObject::setVisible | ( | bool | visible | ) |
| inlineinherited

Tells this object whether to be visible or not, if it has a renderable component.

Note
  An alternative approach of making an object invisible is to detach it from it's SceneNode, or to remove the SceneNode entirely. Detaching a node means that structurally the scene graph changes. Once this change has taken place, the objects / nodes that have been removed have less overhead to the visibility detection pass than simply making the object invisible, so if you do this and leave the objects out of the tree for a long time, it's faster. However, the act of detaching / reattaching nodes is in itself more expensive than setting an object visibility flag, since in the latter case structural changes are not made. Therefore, small or frequent visibility changes are best done using this method; large or more longer term changes are best done by detaching.

## ◆ updateAllBounds()

static void Ogre::MovableObject::updateAllBounds | ( | const size_t | numNodes,
|  | ObjectData | t
| ) |  |
| staticinherited

@See SceneManager::updateAllBounds

Remarks
  We don't pass by reference on purpose (avoid implicit aliasing)

## Member Data Documentation

## ◆ c_DefaultLodMesh

const FastArray<Real> Ogre::MovableObject::c_DefaultLodMesh
| staticinherited

## ◆ mGlobalIndex

size_t Ogre::MovableObject::mGlobalIndex
| inherited

Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).

Used for O(1) removals.

Remarks
  It is the parent (or our creator) the one that sets this value, not ourselves. Do NOT modify it manually.

## ◆ mParentIndex

size_t Ogre::MovableObject::mParentIndex
| inherited

Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).

Used for O(1) removals.

Remarks
  It is the parent (or our creator) the one that sets this value, not ourselves. Do NOT modify it manually.

## ◆ mRenderables

RenderableArray Ogre::MovableObject::mRenderables
| inherited

The documentation for this class was generated from the following file:

- OgreParticleSystem.h